#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <values.h>             // DBL_MAX, maybe
#include <limits.h>             // DBL_MAX, maybe
#include <stdarg.h>
#include <sys/stat.h>           // struct stat, stat()
#include <unistd.h>
#include <fcntl.h>              // O_CREAT


//#ifndef _inc_
//#define _inc_

#include "inifile.hh"
#include "inifile.h"
#include "config.h"
#include "emcglb.h"
#include "emccfg.h"
#include "rcs.hh"               // etime()
#include "emc.hh"               // EMC NML
#include "emc_nml.hh"
#include "rcs_print.hh"
#include "nml_oi.hh"
#include "timer.hh"
//#endif


static int sendEstop();
static int sendEstopReset();
static int sendMachineOn();
static int sendMachineOff();
static int sendManual();
static int sendAuto();
static int sendMdi();
static int sendToolSetOffset(int toolno, double zoffset, double diameter);
static int sendMistOn();
static int sendMistOff();
static int sendFloodOn();
static int sendFloodOff();
static int sendSpindleForward();
static int sendSpindleReverse();
static int sendSpindleOff();
static int sendSpindleIncrease();
static int sendSpindleDecrease();
static int sendSpindleConstant();
static int sendBrakeEngage();
static int sendBrakeRelease();
static int sendAbort();
static int sendOverrideLimits();
static int sendJogStop(int axis);
static int sendJogCont(int axis, double speed);
static int sendJogIncr(int axis, double speed, double incr);
static int sendHome(int axis);
static int sendFeedOverride(double override);
static int sendTaskPlanInit();
static int sendProgramOpen(char *program);
static int sendProgramRun(int line);
static int sendProgramPause();
static int sendProgramResume();
static int sendProgramStep();
static int sendMdiCmd(char *mdi);
static int sendLoadToolTable(const char *file);

static char *upcase(char *string);
static int iniLoad(const char *filename);
static int emcTaskNmlGet();
static int emcErrorNmlGet();
static void printError(const char *error);
static int updateStatus();
static int updateError();
static int emcCommandWaitDone(int serial_number);
